org.apache.lucene.analysis.shingle

## Class ShingleFilter

- java.lang.Object
- - org.apache.lucene.util.AttributeSource
  - - org.apache.lucene.analysis.TokenStream
    - - org.apache.lucene.analysis.TokenFilter
      - - org.apache.lucene.analysis.shingle.ShingleFilter

-     public class ShingleFilter
      extends org.apache.lucene.analysis.TokenFilter

  A ShingleFilter constructs shingles (token n-grams) from a token stream. In other words, it creates combinations of tokens as a single token.

  For example, the sentence "please divide this sentence into shingles" might be tokenized into shingles "please divide", "divide this", "this sentence", "sentence into", and "into shingles".

  This filter handles position increments > 1 by inserting filler tokens (tokens with termtext "_"). It does not handle a position increment of 0.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.apache.lucene.util.AttributeSource

      `org.apache.lucene.util.AttributeSource.AttributeFactory, org.apache.lucene.util.AttributeSource.State`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `DEFAULT_MAX_SHINGLE_SIZE` default maximum shingle size is 2.
    `static char[]` | `FILLER_TOKEN` filler token for when positionIncrement is more than 1
    `static java.lang.String` | `TOKEN_SEPARATOR` The string to use when joining adjacent tokens to form a shingle

    - ### Fields inherited from class org.apache.lucene.analysis.TokenFilter

      `input`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ShingleFilter(org.apache.lucene.analysis.TokenStream input)` Construct a ShingleFilter with default shingle size.
    `ShingleFilter(org.apache.lucene.analysis.TokenStream input, int maxShingleSize)` Constructs a ShingleFilter with the specified single size from the `TokenStream` `input`
    `ShingleFilter(org.apache.lucene.analysis.TokenStream input, java.lang.String tokenType)` Construct a ShingleFilter with the specified token type for shingle tokens.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `incrementToken()`
    `org.apache.lucene.analysis.Token` | `next()` Deprecated. Will be removed in Lucene 3.0. This method is final, as it should not be overridden. Delegates to the backwards compatibility layer.
    `org.apache.lucene.analysis.Token` | `next(org.apache.lucene.analysis.Token reusableToken)` Deprecated. Will be removed in Lucene 3.0. This method is final, as it should not be overridden. Delegates to the backwards compatibility layer.
    `void` | `reset()`
    `void` | `setMaxShingleSize(int maxShingleSize)` Set the max shingle size (default: 2)
    `void` | `setOutputUnigrams(boolean outputUnigrams)` Shall the output stream contain the input tokens (unigrams) as well as shingles? (default: true.)
    `void` | `setTokenType(java.lang.String tokenType)` Set the type of the shingle tokens produced by this filter.

    - ### Methods inherited from class org.apache.lucene.analysis.TokenFilter

      `close, end`

    - ### Methods inherited from class org.apache.lucene.analysis.TokenStream

      `getOnlyUseNewAPI, setOnlyUseNewAPI`

    - ### Methods inherited from class org.apache.lucene.util.AttributeSource

      `addAttribute, addAttributeImpl, captureState, clearAttributes, cloneAttributes, equals, getAttribute, getAttributeClassesIterator, getAttributeFactory, getAttributeImplsIterator, hasAttribute, hasAttributes, hashCode, restoreState, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### FILLER_TOKEN

          public static final char[] FILLER_TOKEN

      filler token for when positionIncrement is more than 1

    - #### DEFAULT_MAX_SHINGLE_SIZE

          public static final int DEFAULT_MAX_SHINGLE_SIZE

      default maximum shingle size is 2.
      See Also:
        Constant Field Values

    - #### TOKEN_SEPARATOR

          public static final java.lang.String TOKEN_SEPARATOR

      The string to use when joining adjacent tokens to form a shingle
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### ShingleFilter

          public ShingleFilter(org.apache.lucene.analysis.TokenStream input,
                               int maxShingleSize)

      Constructs a ShingleFilter with the specified single size from the `TokenStream` `input`
      Parameters:
        `input` - input stream
        `maxShingleSize` - maximum shingle size produced by the filter.

    - #### ShingleFilter

          public ShingleFilter(org.apache.lucene.analysis.TokenStream input)

      Construct a ShingleFilter with default shingle size.
      Parameters:
        `input` - input stream

    - #### ShingleFilter

          public ShingleFilter(org.apache.lucene.analysis.TokenStream input,
                               java.lang.String tokenType)

      Construct a ShingleFilter with the specified token type for shingle tokens.
      Parameters:
        `input` - input stream
        `tokenType` - token type for shingle tokens

  - ### Method Detail

    - #### setTokenType

          public void setTokenType(java.lang.String tokenType)

      Set the type of the shingle tokens produced by this filter. (default: "shingle")
      Parameters:
        `tokenType` - token tokenType

    - #### setOutputUnigrams

          public void setOutputUnigrams(boolean outputUnigrams)

      Shall the output stream contain the input tokens (unigrams) as well as shingles? (default: true.)
      Parameters:
        `outputUnigrams` - Whether or not the output stream shall contain the input tokens (unigrams)

    - #### setMaxShingleSize

          public void setMaxShingleSize(int maxShingleSize)

      Set the max shingle size (default: 2)
      Parameters:
        `maxShingleSize` - max size of output shingles

    - #### incrementToken

          public final boolean incrementToken()
                                       throws java.io.IOException

      Overrides:
        `incrementToken` in class `org.apache.lucene.analysis.TokenStream`
      Throws:
        `java.io.IOException`

    - #### next

          public final org.apache.lucene.analysis.Token next(org.apache.lucene.analysis.Token reusableToken)
                                                      throws java.io.IOException

      Deprecated. Will be removed in Lucene 3.0. This method is final, as it should not be overridden. Delegates to the backwards compatibility layer.
      Overrides:
        `next` in class `org.apache.lucene.analysis.TokenStream`
      Throws:
        `java.io.IOException`

    - #### next

          public final org.apache.lucene.analysis.Token next()
                                                      throws java.io.IOException

      Deprecated. Will be removed in Lucene 3.0. This method is final, as it should not be overridden. Delegates to the backwards compatibility layer.
      Overrides:
        `next` in class `org.apache.lucene.analysis.TokenStream`
      Throws:
        `java.io.IOException`

    - #### reset

          public void reset()
                     throws java.io.IOException

      Overrides:
        `reset` in class `org.apache.lucene.analysis.TokenFilter`
      Throws:
        `java.io.IOException`

Copyright © 2000-2016 Apache Software Foundation. All Rights Reserved.